(*****************************************************************************)
(*  robot_actif.ml :                                                         *)
(*                                                                           *)
(* POD : E.Chailloux  P.Manoury  B.Pagano                                    *)
(*****************************************************************************)

(*************************************************************************)
(*                       ROBOT ET MONDE ACTIFS                           *)
(*************************************************************************)

open Robot_def

class virtual ['a] mondeV_actifV = 
  object (s)
    method private virtual move_robot : 'a -> unit 
    method virtual go : unit 
end





class virtual ['a] mondeV_iteratif () =
  object (s)
    inherit ['a] mondeV_actifV

    method private move_robot r =
      let pos = s#normalize (r#next_position s)
      in if (s#is_free pos && s#is_legal pos) then r#set_pos pos

    method go = while true do List.iter s#move_robot s#get_roblist done
end



open Robot_display 


(* exemple : le monde ferme , actif et display en texte *)

class ['a] ferme_actif_txt hi li =
 object (s)
    inherit ['a] mondeV_iteratif () as super
    inherit ['a] mondeV_txt ()
    inherit ['a] monde_ferme hi li       
    (* un robot s'affiche a chaque deplacement *)
    method private move_robot r = super#move_robot r ; s#display 

  end 




(* les mondes graphiques et iteratifs *)


class virtual ['a] mondeV_iteratif_graph gc =
  object (s)
    inherit ['a] mondeV_graph gc
    inherit ['a] mondeV_iteratif () as super
    method private move_robot r = super#move_robot r ; s#display ;
end


class ['a] ferme_actif_graph hi li gc =
 object (s)
    inherit ['a] mondeV_iteratif_graph gc
    inherit ['a] monde_ferme hi li       
  end 





